
%token OF_TYPE REWRITES_TO BOUNDED_TO EOS EOF EOL
%token LBRACKET RBRACKET
%token <int>INT
%token <char> VAR_TERMINAL
%token <char>  NONTERMINAL 
%token  OMICRON
%start main main2 main3 autnr delta
%type <Hors.pair_list>  main
%type <Hors.pair_list> main2
%type <Hors.triple_list> main3
%type <int> autnr
%type <Automata.d> delta
%%

main:
  |sigma {$1};

sigma:
  |VAR_TERMINAL OF_TYPE myType EOL 
     sigma{Hors.C($1)::Hors.K($3)::$5}
  |EOL {[]};

myType:
  |OMICRON {Hors.Omicron}
  |OMICRON myType {Hors.Arrow(Hors.Omicron,$2)}
  |LBRACKET myType RBRACKET myType {Hors.Arrow($2,$4)}
  |LBRACKET myType RBRACKET {$2};
 
main2:
  |nset{$1};

nset:
   |NONTERMINAL OF_TYPE myType EOL nset{Hors.C($1)::Hors.K($3)::$5}
   |EOL {[]};

main3:
  |rset {$1};

rset:
  |NONTERMINAL REWRITES_TO vars BOUNDED_TO term EOL rset{Hors.S($1)::Hors.V($3)::Hors.T($5)::$7}
  |NONTERMINAL REWRITES_TO BOUNDED_TO term EOL rset{Hors.S($1)::Hors.V([])::Hors.T($4)::$6}
  |EOL{[]};

vars:
  |VAR_TERMINAL vars {$1::$2}
  |VAR_TERMINAL {$1::[]};

term:
  |symbol {Hors.Symbol($1,ref [])}
  |term LBRACKET term RBRACKET  {Hors.App($1,$3)}
  |term symbol{Hors.App($1,Hors.Symbol($2, ref []))}
  |LBRACKET term RBRACKET {$2};

symbol:
  |VAR_TERMINAL{$1}
  |NONTERMINAL{$1};

autnr:
  |INT EOL {$1};

delta:
  |delta1 {$1};

delta1:
  |INT VAR_TERMINAL qlist delta1 
     {{Automata.di=$1;Automata.dc=$2;Automata.dq=$3}::$4}
  |EOL {[]};

qlist:
  |INT qlist{$1::$2}
  |EOL{[]};
